//
//
//  This demonstrates RLE decoding
//
//  Created 12-DEC-1997   Richard B. Johnson
//  Program released to the public domain, Richard B. Johnson
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "rle.h"

#define DEB(f)


//
//  Decode an input string and return its resulting length. Warning, the
//  output length is not checked. Therefore, the outpuf buffer size must
//  have been set large enough to hold the result.
//
size_t rle_decode(unsigned char *obuf, unsigned char *ibuf, size_t buf_len)
{
	unsigned char uc;
	unsigned char *begin;
	size_t how_many;
	int what_kind, len;
	len = (int) buf_len;
	begin = obuf;
	while(len-- > 0)
	{
         uc = *ibuf++;
         if(uc == TOKEN)
		 {
			 how_many  = (size_t) *ibuf++;
			 what_kind = (int)    *ibuf++;
			 DEB(fprintf(stderr, "How many = %u. what_kind = %d\n", how_many, what_kind));
			 memset(obuf, what_kind, how_many);
			 obuf += how_many;
			 len  -= 2;
			 continue;
		 }
		 *obuf++ = uc;
	}
	return obuf - begin;
}

