//
//
//  This demonstrates RLE encoding
//
//  Created 12-DEC-1997   Richard B. Johnson
//  Program released to the public domain, Richard B. Johnson
//

#include <stdio.h>
#include <stdlib.h>

#include "rle.h"
#define MIN(a, b) ((a) < (b) ? (a):(b))

#define DEB(f)

//
//  Encode an input string and return its resulting length.
//

size_t rle_encode(unsigned char *obuf, unsigned char *ibuf, size_t len)
{
	unsigned char uc, prev, *begin;
	size_t run_length, total, count;
	prev  = *ibuf;
	begin = obuf;
	total = 0x00;
	while(len)
	{
		uc = *(++ibuf);	            // Get data byte
		if(uc == prev)              // Same as previous?
		{
			count = MIN(0xff, len);
			*obuf++ = (char) TOKEN; // Token to output string
            run_length = 0x00;
            while(count--)
			{
				if ((uc = *(++ibuf)) != prev)
					break;
				run_length++;
			}
			len -= run_length;
			DEB(fprintf(stderr, "len = %u, length = %u, kind = %u\n", len, run_length, uc));
			*obuf++ = (unsigned char) run_length;
			*obuf++ = uc;
			prev    = uc;
        	total  += run_length;
			continue;
		}
 		*obuf++ = uc;
		prev    = uc;
		len--;
	}
	obuf--;
	DEB(fprintf(stderr, "Return value was %u (%u)\n", (obuf - begin), total));
	return (obuf - begin);
}

